<?php
if ( ! class_exists( 'Rename_Attr_System_Col' ) ) :

    class Rename_Attr_System_Col {
        private $migration_version = '0.3';

        function run_migration() {
            $wclsi_db_version = get_option( WCLSI_DB_VERSION_OPTION, '0.0' );
            if ( version_compare( $wclsi_db_version, $this->migration_version ) < 0 ) {
                $this->rename_system_to_sys();
                update_option( WCLSI_DB_VERSION_OPTION, $this->migration_version );
            }
        }

        function rename_system_to_sys() {
            global $wpdb, $WCLSI_ITEM_ATTRIBUTE_SETS_TABLE;

            $old_col_exists = ! is_null( $wpdb->get_var( "SHOW COLUMNS FROM {$WCLSI_ITEM_ATTRIBUTE_SETS_TABLE} LIKE 'system'" ) );

            if ( $old_col_exists ) {
                $wpdb->query( "ALTER TABLE $WCLSI_ITEM_ATTRIBUTE_SETS_TABLE CHANGE `system` sys TINYINT(1) DEFAULT 0;" );
                if ( ! empty( $wpdb->last_error ) ) {
                    $error_msg = "There was a problem with a database migration with the Lightspeed plugin: {$wpdb->last_error}";
                    if ( is_admin() ) {
                        add_settings_error(
                            "wclsi_settings",
                            "wclsi_migration_failed",
                            $error_msg
                        );
                    }

                    $WCLSI_WC_Logger = new WC_Logger();
                    $WCLSI_WC_Logger->add( 'wclsi-errors-log', $error_msg );
                }
            }
        }
    }

endif;
