<?php
if ( ! class_exists( 'Change_Upc_And_Ean_To_Bigint' ) ) :

    class Change_Upc_And_Ean_To_Bigint {

        private $migration_version = '0.5';

        function __construct() {

        }

        function run_migration() {
            $wclsi_db_version = get_option( WCLSI_DB_VERSION_OPTION, '0.0' );
            if ( version_compare( $wclsi_db_version, $this->migration_version ) < 0 ) {
                $this->change_upc_and_ean_to_bigint();
                update_option( WCLSI_DB_VERSION_OPTION, $this->migration_version );
            }
        }


        function change_upc_and_ean_to_bigint() {
            global $wpdb, $WCLSI_ITEM_TABLE;

            $wpdb->query( "ALTER TABLE $WCLSI_ITEM_TABLE MODIFY ean BIGINT(20)" );
            if ( ! empty( $wpdb->last_error ) ) {
                $error_msg = "There was a problem with a database migration with the Lightspeed plugin: {$wpdb->last_error}";
                if ( is_admin() ) {
                    add_settings_error(
                        "wclsi_settings",
                        "wclsi_migration_failed",
                        $error_msg
                    );
                }

                $WCLSI_WC_Logger = new WC_Logger();
                $WCLSI_WC_Logger->add( 'wclsi-errors-log', $error_msg );
            }

            $wpdb->query( "ALTER TABLE $WCLSI_ITEM_TABLE MODIFY upc BIGINT(20)" );
            if ( ! empty( $wpdb->last_error ) ) {
                $error_msg = "There was a problem with a database migration with the Lightspeed plugin: {$wpdb->last_error}";
                if ( is_admin() ) {
                    add_settings_error(
                        "wclsi_settings",
                        "wclsi_migration_failed",
                        $error_msg
                    );
                }

                $WCLSI_WC_Logger = new WC_Logger();
                $WCLSI_WC_Logger->add( 'wclsi-errors-log', $error_msg );
            }
        }

    }


endif;