<?php
if ( ! class_exists( 'WCLSI_Product_Attributes_Sets_Poller' ) ) :
    class WCLSI_Product_Attributes_Sets_Poller {
        public static function init() {
            add_action( 'init', array( get_called_class(), 'schedule_lightspeed_product_attributes_poller' ), 10 );
            add_action( 'wclsi_poll_ls_attribute_sets', array(
                get_called_class(),
                'poll_lightspeed_product_attribute_sets'
            ), 10 );
        }

        static function schedule_lightspeed_product_attributes_poller() {
            global $WCLSI;

            $is_enabled = $WCLSI->settings[ WCLSI_ATTR_SETS_POLLER_SETTINGS ]['is_enabled'] ?? false;
            if ( 'true' !== $is_enabled ) {
                if ( false !== as_next_scheduled_action( 'wclsi_poll_ls_attribute_sets' ) ) {
                    as_unschedule_all_actions( 'wclsi_poll_ls_attribute_sets' );
                }

                return;
            }

            if ( false === as_next_scheduled_action( 'wclsi_poll_ls_attribute_sets' ) ) {
                $interval = $WCLSI->settings[ WCLSI_ATTR_SETS_POLLER_SETTINGS ]['interval'] ?? 3600;
                as_schedule_recurring_action( strtotime( "+{$interval} second" ), $interval, 'wclsi_poll_ls_attribute_sets', array(), 'wclsi' );
                wclsi_cleanup_duplicate_jobs( 'wclsi_poll_ls_attribute_sets' );
            }
        }

        static function poll_lightspeed_product_attribute_sets() {
            global $WCLSI_PRODS;
            $WCLSI_PRODS->pull_item_attribute_sets();
        }
    }
endif;

WCLSI_Product_Attributes_Sets_Poller::init();
