<?php
define( 'WCLSI_SETTINGS_MENU_NAME', __( 'Settings', 'woocommerce-lightspeed-pos' ) );
define( 'WCLSI_PROD_IMPORTER_MENU_NAME', __( 'Product Importer', 'woocommerce-lightspeed-pos' ) );
define( 'WCLSI_IMPORTER_PAGE_TITLE', __( 'Lightspeed Importer', 'woocommerce-lightspeed-pos' ) );
define( 'WCLSI_ADMIN_URL', admin_url( 'admin.php?page=wclsi' ) );
define( 'WCLSI_ADMIN_SETTINGS_URL', admin_url( 'admin.php?page=wc-settings&tab=integration&section=lightspeed-integration' ) );

const WCLSI_VERSION                   = '2.16.0';
const WCLSI_DB_VERSION_OPTION         = 'wclsi_db_version';
const WCLSI_ATTRS_CACHE               = 'wclsi_attrs_cache';
const WCLSI_SYNC_POST_META            = '_wclsi_sync';
const WCLSI_LAST_SYNC_TIMESTAMP       = 'wclsi_last_sync_timestamp';
const WCLSI_REPORT_ERRORS             = 'wclsi_report_errors';
const WCLSI_INVENTORY_SHOP_ID         = 'ls_inventory_store';
const WCLSI_REGISTER_ID               = 'wclsi_sales_register';
const WCLSI_EMPLOYEE_ID               = 'wclsi_sales_employee';
const WCLSI_TAX_CATEGORY_ID           = 'wclsi_tax_category';
const WCLSI_PAYMENT_TYPE_ID           = 'wclsi_payment_type_id';
const WCLSI_SINGLE_ITEM_ID_POST_META  = '_wclsi_item_id';
const WCLSI_MATRIX_ID_POST_META       = '_wclsi_matrix_id';
const WCLSI_LAST_LOAD_TIMESTAMP       = 'wclsi_load_timestamp';
const WCLSI_LS_TO_WC_AUTOLOAD         = 'ls_to_wc_auto_load';
const WCLSI_AUTOLOAD_AFTER_ACTION     = 'autoload_after_action';
const WCLSI_PRUNE_DELETED_VARIATIONS  = 'wclsi_prune_deleted_variations';
const WCLSI_POLLER_SETTING            = 'wclsi_poller_setting';
const WCLSI_ATTR_SETS_POLLER_SETTINGS = 'wclsi_poll_prod_attribute_sets';
const WCLSI_IGNORE_ARCHIVED_LS_PRODS  = 'wclsi_ignore_archived_ls_prods';
const WCLSI_IMPORT_ON_AUTOLOAD        = 'wclsi_import_on_auto_load';
const WCLSI_WC_SELECTIVE_SYNC         = 'wclsi_wc_selective_sync';
const WCLSI_LS_SELECTIVE_SYNC         = 'wclsi_ls_selective_sync';
const WCLSI_DOCS_URL                  = 'https://docs.woothemes.com/document/woocommerce-lightspeed-pos/';
const WCLSI_ITEM_POLL                 = 'wclsi_item_poll';
const WCLSI_API_BUCKET_LEVEL          = 'wclsi_api_bucket_level';
const WCLSI_API_BUCKET_LEVEL_MAX      = 'wclsi_api_bucket_level_max';
const WCLSI_API_DRIP_RATE             = 'wclsi_api_drip_rate';
const WCLSI_SYNCING_PROD_TO_LS        = 'wclsi_syncing_prod_to_ls';
const WCLSI_NOTIFICATIONS             = 'wclsi_notifications';
const WCLSI_REMOVE_DEFAULT_CAT        = 'wclsi_remove_default_category';
const WCLSI_SALES_SYNC                = 'wclsi_sales_sync';
const WCLSI_CACHE                     = 'wclsi_cache';
const WCLSI_LS_DEFAULT_TAX_RATE       = '0.00';
const WCLSI_VARIATION_LIMIT           = 30;

global $WCLSI_ITEM_TABLE,
       $WCLSI_ITEM_IMAGES_TABLE,
       $WCLSI_ITEM_SHOP_TABLE,
       $WCLSI_ITEM_PRICES_TABLE,
       $WCLSI_ITEM_E_COMMERCE_TABLE,
       $WCLSI_ITEM_CATEGORIES_TABLE,
       $WCLSI_ITEM_ATTRIBUTE_SETS_TABLE,
       $WCLSI_RELATED_ITEM_TABLES,
       $WCLSI_TAX_LOOKUP_TABLE,
       $WCLSI_SINGLE_LOAD_RELATIONS,
       $WCLSI_MATRIX_LOAD_RELATIONS,
       $WCLSI_ALL_TABLES,
       $WCLSI_objectL10n,
       $WC_PROD_SELECTIVE_SYNC_PROPERTIES,
       $LS_PROD_SELECTIVE_SYNC_PROPERTIES,
       $WCLSI_SKU_STRATEGIES,
       $WCLSI_JOB_INTERVALS,
       $WCLSI_NEW_LS_PROD_BEHAVIOR,
       $WCLSI_IMAGE_COMPRESSION_STRATEGIES,
       $WCLSI_SALES_SYNC_STRATEGIES,
       $WCLSI_MAX_COMBINED_TAX_RATES;

global $wpdb;
$WCLSI_ITEM_TABLE                = "{$wpdb->prefix}wclsi_items";
$WCLSI_ITEM_IMAGES_TABLE         = "{$wpdb->prefix}wclsi_item_images";
$WCLSI_ITEM_SHOP_TABLE           = "{$wpdb->prefix}wclsi_item_shops";
$WCLSI_ITEM_PRICES_TABLE         = "{$wpdb->prefix}wclsi_item_prices";
$WCLSI_ITEM_E_COMMERCE_TABLE     = "{$wpdb->prefix}wclsi_item_e_commerce";
$WCLSI_ITEM_CATEGORIES_TABLE     = "{$wpdb->prefix}wclsi_item_categories";
$WCLSI_ITEM_ATTRIBUTE_SETS_TABLE = "{$wpdb->prefix}wclsi_item_attribute_sets";
$WCLSI_TAX_LOOKUP_TABLE          = "{$wpdb->prefix}wclsi_tax_lookup";
$WP_POSTS                        = "{$wpdb->prefix}posts";
$WP_POSTMETA                     = "{$wpdb->prefix}postmeta";


$WCLSI_RELATED_ITEM_TABLES = array(
	$WCLSI_ITEM_IMAGES_TABLE,
	$WCLSI_ITEM_SHOP_TABLE,
	$WCLSI_ITEM_PRICES_TABLE,
	$WCLSI_ITEM_E_COMMERCE_TABLE
);

$WCLSI_ALL_TABLES = array(
	$WCLSI_ITEM_TABLE,
	$WCLSI_ITEM_SHOP_TABLE,
	$WCLSI_ITEM_PRICES_TABLE,
	$WCLSI_ITEM_IMAGES_TABLE,
	$WCLSI_ITEM_E_COMMERCE_TABLE,
	$WCLSI_ITEM_CATEGORIES_TABLE,
	$WCLSI_ITEM_ATTRIBUTE_SETS_TABLE
);

$WCLSI_SINGLE_LOAD_RELATIONS = array(
	"ItemShops",
	"ItemECommerce",
	"Images",
	"Tags",
	"ItemAttributes",
	"CustomFieldValues"
);
$WCLSI_MATRIX_LOAD_RELATIONS = array(
	"ItemECommerce",
	"Tags",
	"Images"
);

$WCLSI_objectL10n = array(
	'reload_confirm'          => __( 'Products have already been loaded, are you sure you want to reload them?', 'woocommerce-lightspeed-pos' ),
	'importing_prods'         => __( 'Importing Lightspeed products ... ', 'woocommerce-lightspeed-pos' ),
	'updating_prods'          => __( 'Updating Lightspeed products ... ', 'woocommerce-lightspeed-pos' ),
	'dont_close'              => __( 'This may take a while... please do not close this window while products are being processed!', 'woocommerce-lightspeed-pos' ),
	'done_importing'          => sprintf( __( 'Import completed! Click <a href="%s">here</a> to view imported products', 'woocommerce-lightspeed-pos' ), admin_url( 'edit.php?post_type=product' ) ),
	'no_prods_error'          => __( 'Error: No products to import!', 'woocommerce-lightspeed-pos' ),
	'try_again'               => __( 'A connection could not be made to Lightspeed, please try again.', 'woocommerce-lightspeed-pos' ),
	'sync_error'              => __( 'Please import this item before attempting to link it!', 'woocommerce-lightspeed-pos' ),
	'sync_success'            => __( 'Product successfully linked with WooCommerce.', 'woocommerce-lightspeed-pos' ),
	'relink_success'          => __( 'Linking successful! The associated Lightspeed product should now be viewable on the <a href="' . WCLSI_ADMIN_URL . '">Lightspeed Import page</a>.', 'woocommerce-lightspeed-pos' ),
	'sync_remove'             => __( 'Product successfully removed from sync schedule.', 'woocommerce-lightspeed-pos' ),
	'syncing'                 => __( 'Syncing...', 'woocommerce-lightspeed-pos' ),
	'man_sync_success'        => __( 'Successfully synced!', 'woocommerce-lightspeed-pos' ),
	'prod_processing_error'   => __( 'Uh oh! There were some errors with processing some of the products.', 'woocommerce-lightspeed-pos' ),
	'generic_error'           => __( 'Something went wrong! Please try again later.', 'woocommerce-lightspeed-pos' ),
	'provide_account_id'      => __( 'Please provide an account ID before submitting!', 'woocommerce-lightspeed-pos' ),
	'api_connection_good'     => __( 'Connection successful!', 'woocommerce-lightspeed-pos' ),
	'api_connection_bad'      => __( 'A connection could not be made to your Lightspeed account!', 'woocommerce-lightspeed-pos' ),
	'incomplete_load'         => __( 'Error: something went wrong with loading products from Lightspeed! Refresh to see if some products loaded successfully.', 'woocomerce-lightspeed-pos' ),
	'loading_matrix_products' => __( 'Loading matrix products', 'woocommerce-lightspeed-pos' ),
	'loading_categories'      => __( 'Loading categories', 'woocommerce-lightspeed-pos' ),
	'loading_item_attrs'      => __( 'Loading item attribute sets', 'woocommerce-lightspeed-pos' ),
	'upgrade_complete'        => __( 'Upgrade successfully completed!', 'woocommerce-lightspeed-pos' ),
	'bad_sync_to_ls'          => __( 'The synchronization to Lightspeed experienced some issues. Please log into Lightspeed and verify your product was synced properly.' ),
	'cat_cache_clear_success' => __( 'Category cache successfully cleared!', 'woocommerce-lightspeed-pos' ),
	'processing_order'        => __( 'Processing products', 'woocommerce-lightspeed-pos' ),
	'ls_out_of_stock'         => __( 'We apologize, one or more of the items' ),
	'background_image_import' => __( 'Product images are imported via the action scheduler and may take some time to be applied to products.', 'woocommerce-lightspeed-pos' ),
	'taxes_exporting'         => __( 'Tax categories are being exported to Lightspeed via the action scheduler. This may take a while. You do not need to stay on this page while this process completes.', 'woocomerce-lightspeed-pos' ),
	'taxes_deleting'          => __( 'Tax categories are being deleted from Lightspeed via the action scheduler. This may take a while. You do not need to stay on this page while this process completes.', 'woocomerce-lightspeed-pos' ),
	'save_before_leaving'     => __( 'Make sure to save any changes you made before leaving the page!', 'woocommerce-lightspeed-pos' ),
);

$WC_PROD_SELECTIVE_SYNC_PROPERTIES = array(
	'name'              => 'Name',
	'sku'               => 'SKU (see SKU strategy setting)',
	'regular_price'     => 'Regular Price',
	'sale_price'        => 'Sale Price',
	'stock_quantity'    => 'Stock Quantity',
	'images'            => 'Images (both featured and gallery images)',
	'attributes'        => 'Attributes (for Matrix/Variable products)',
	'tags'              => 'Tags',
	'short_description' => 'Short Description',
	'description'       => 'Long Description',
	'weight'            => 'Weight',
	'length'            => 'Length',
	'width'             => 'Width',
	'height'            => 'Height',
);

$LS_PROD_SELECTIVE_SYNC_PROPERTIES = array(
	'description'      => 'Name',
	'customSku'        => 'SKU (maps to Custom SKU in LightSpeed)',
	'regular_price'    => 'Regular Price',
	'sale_price'       => 'Sale Price',
	'stock_quantity'   => 'Stock Quantity',
	'shortDescription' => 'Short Description',
	'longDescription'  => 'Long Description',
	'weight'           => 'Weight',
	'length'           => 'Length',
	'width'            => 'Width',
	'height'           => 'Height',
);

$WCLSI_SKU_STRATEGIES = array(
	array( 'text' => 'System SKU', 'value' => 'system_sku' ),
	array( 'text' => 'Custom SKU', 'value' => 'custom_sku' ),
	array( 'text' => "Manufacturer's SKU", 'value' => 'man_sku' ),
	array( 'text' => 'Plugin Default', 'value' => 'plugin_default' )
);

$WCLSI_JOB_INTERVALS = array(
	5    => array( 'text' => '5 seconds', 'value' => 5 ),
	30   => array( 'text' => '30 seconds', 'value' => 30 ),
	60   => array( 'text' => '1 minute', 'value' => 60 ),
	120  => array( 'text' => '2 minutes', 'value' => 120 ),
	300  => array( 'text' => '5 minutes', 'value' => 300 ),
	600  => array( 'text' => '10 minutes', 'value' => 600 ),
	900  => array( 'text' => '15 minutes', 'value' => 900 ),
	1800 => array( 'text' => '30 minutes', 'value' => 1800 ),
	3600 => array( 'text' => '1 hour', 'value' => 3600 )
);

$WCLSI_IMAGE_COMPRESSION_STRATEGIES = array(
	array( 'text' => 'Low', 'value' => 'q_auto:low' ),
	array( 'text' => 'Better', 'value' => 'q_auto:eco' ),
	array( 'text' => 'Best', 'value' => 'q_auto:best' ),
	array( 'text' => 'Plugin Default', 'value' => 'q_auto:eco' )
);


$WCLSI_HANDLE_ARCHIVED_PRODUCT_STRATEGIES = array(
	array( 'text' => 'Do Nothing', 'value' => 'do nothing' ),
	array( 'text' => 'Remove from WooCommerce', 'value' => 'delete' ),
	array( 'text' => 'Change Product to "Draft" state', 'value' => 'draft' ),
//	array( 'text' => 'Move Product to Trash Bin', 'value' => 'trash bin' ),
	array( 'text' => 'Plugin Default', 'value' => 'do nothing' )
);

$WCLSI_SALES_SYNC_STRATEGIES = array(
	array( 'text' => 'Processing', 'value' => 'woocommerce_order_status_processing' ),
	array( 'text' => 'Completed', 'value' => 'woocommerce_order_status_completed' ),
);

$WCLSI_MAX_COMBINED_TAX_RATES = 3;
